---
# Tasks file for vscode

###############################################################################
# Install vscode ONLY ON RedHat.  
###############################################################################
- name: Add vscode repo - RedHat ONLY
  shell: 
    cmd: | 
      rpm --import https://packages.microsoft.com/keys/microsoft.asc
      sh -c 'echo -e "[code]\nname=Visual Studio Code\nbaseurl=https://packages.microsoft.com/yumrepos/vscode\nenabled=1\ngpgcheck=1\ngpgkey=https://packages.microsoft.com/keys/microsoft.asc" > /etc/yum.repos.d/vscode.repo'
  args:
    warn: false 
  become: yes
  become_user: root
  when: ansible_os_family == 'RedHat'

- name: Install vscode - RedHat ONLY
  ansible.builtin.package:
    name:
      - code
    update_cache: yes
    state: latest
  when: ansible_os_family == 'RedHat'

#Add if you need to add a proxy to vscode
#- name: Add vscode proxy settings in settings.json - RedHat ONLY
#  copy:
#    dest: /home/{{ lookup('env', 'USER') }}/.config/Code/User/settings.json
#    content: |
#      {
#          "http.proxy": "http://www.proxy.com:port"
#      }
#    mode: '0664'
#  when: ansible_os_family == 'RedHat'
#  #ignore_errors: yes


###############################################################################
# Install vscode ONLY ON Debian.  
###############################################################################
- name: Add microsoft key to new gpg keyring - DEBIAN ONLY
  ansible.builtin.apt_key:
    url: https://packages.microsoft.com/keys/microsoft.asc
    keyring: /etc/apt/trusted.gpg.d/packages.microsoft.gpg
    state: present
  when: ansible_os_family == 'Debian'

- name: Install vscode repository - DEBIAN ONLY
  apt_repository:
    repo: 'deb [arch=amd64,arm64,armhf signed-by=/etc/apt/trusted.gpg.d/packages.microsoft.gpg] https://packages.microsoft.com/repos/code stable main'
    filename: vscode
    state: present
  when: ansible_os_family == 'Debian'

- name: Install vscode - DEBIAN ONLY
  ansible.builtin.package:
    name:
      - code
    update_cache: yes
    state: latest
  when: ansible_os_family == 'Debian'

- name: Create vscode settings dir - DEBIAN ONLY
  ansible.builtin.file:
    path: /home/{{ lookup('env', 'USER') }}/.config/Code/User
    state: directory
    owner: "{{ lookup('env', 'USER') }}"
    group: "{{ lookup('env', 'USER') }}"
    mode: '0700'
  when: ansible_os_family == 'Debian'

#Add if you need to add a proxy to vscode
#- name: Add vscode proxy settings in settings.json - DEBIAN ONLY
#  copy:
#    dest: /home/{{ lookup('env', 'USER') }}/.config/Code/User/settings.json
#    content: |
#      {
#          "http.proxy": "http://www.proxy.com:port"
#      }
#    mode: '0664'
#  when: ansible_os_family == 'Debian'
#  #ignore_errors: yes

